/* Generated by Frama-C */
#include "stddef.h"
#include "stdint.h"
#include "stdio.h"
extern  __attribute__((__FC_BUILTIN__)) int __e_acsl_sound_verdict;

struct msgA {
   int type ;
   int a[2] ;
};
struct msgB {
   int type ;
   double x ;
};
struct __anonstruct_T_1 {
   int type ;
};
union msg {
   struct __anonstruct_T_1 T ;
   struct msgA A ;
   struct msgB B ;
};
void read_sensor_4(unsigned int *m)
{
  __e_acsl_store_block((void *)(& m),(size_t)8);
  __e_acsl_initialize((void *)m,sizeof(unsigned int));
  *m = (unsigned int)0;
  __e_acsl_delete_block((void *)(& m));
  return;
}

int main(void)
{
  int __retres;
  unsigned char buf[sizeof(union msg)];
  int i;
  __e_acsl_memory_init((int *)0,(char ***)0,(size_t)8);
  __e_acsl_store_block((void *)(buf),(size_t)16);
  i = 0;
  while ((unsigned long)i < sizeof(buf) / (unsigned long)4) {
    read_sensor_4((unsigned int *)(buf) + i);
    i ++;
  }
  {
    int __gen_e_acsl_initialized;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data = {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,
                                 "(unsigned char *)buf",(void *)(buf));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,
                                   "sizeof(union msg)",0,sizeof(union msg));
    __gen_e_acsl_initialized = __e_acsl_initialized((void *)(buf),
                                                    sizeof(union msg));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,
                                 "\\initialized((union msg *)((unsigned char *)buf))",
                                 0,__gen_e_acsl_initialized);
    __gen_e_acsl_assert_data.blocking = 1;
    __gen_e_acsl_assert_data.kind = "Assertion";
    __gen_e_acsl_assert_data.pred_txt = "\\initialized((union msg *)((unsigned char *)buf))";
    __gen_e_acsl_assert_data.file = "tests/bts/bts1304.i";
    __gen_e_acsl_assert_data.fct = "main";
    __gen_e_acsl_assert_data.line = 32;
    __e_acsl_assert(__gen_e_acsl_initialized,& __gen_e_acsl_assert_data);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data);
  }
  /*@ assert \initialized((union msg *)((unsigned char *)buf)); */ ;
  __retres = 0;
  __e_acsl_delete_block((void *)(buf));
  __e_acsl_memory_clean();
  return __retres;
}


